#define F_CPU 1000000
#include <avr/io.h>
#include <inttypes.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/pgmspace.h>

#define rst 3
#define clk 4
#define data 2
#define dclk 1
#define strobe 0



//Tutej znajduje sie napis:
#define fc 12
unsigned	char n[fc] PROGMEM = {
//								0x80, 0xf7, 0xf7, 0x80, 0xff, 0x80, 0xb6, 0xb6, 0xbe, 0xff, 0xde, 0xbe, 0xc0, 0xff, 0xff
									~0x08, ~0x04, ~0x02, ~0x01, ~0x02, ~0x04, ~0x08, ~0x10, ~0x20, ~0x40, ~0x20, ~0x10	
								};
//koniec napisu
int main()
{

	DDRB = 0xff;			
	char anime = 0; //numer aktualnie wyświetlanej klatki	
	char time = 0;	//zmienna pomocnicza do odmierzania czasu
	while(1)	//pętla główna
	{
	char i;	
	for(i = 0; i < 7; i++)	//pętla odpowiedzialna za włączanie kolejnych kolumn
	{
		signed char j;
		for(j = 4; j >= 0; j--)	//pętla odpowiedzialna za wgrywanie danych do rejestru
			{
			PORTB &= ~(1<<data);		
			char frame = j+anime;		
			if(frame >= fc) frame-=fc;	
			PORTB |= (( pgm_read_byte(&n[frame])>>i)&1)<<data;
			PORTB |= 1<<dclk;
			PORTB &= ~(1<<dclk);
			}
		PORTB |= 1 << strobe; //włącza diody
		_delay_ms(2);
		PORTB &= ~(1<<strobe); //gasi diody
		PORTB |= 1 << clk;
		PORTB &= ~(1 << clk);
	}
	PORTB |= 1 << rst;
	PORTB &= ~(1 << rst);
	time++;
	if(time > 15)	//czas wyświetlania zalezy od tego parametru, 
	//15 oznacza, że zmiana następuje po 15 wyświetleniach poprzedniej klatki animacji
		{
		time = 0;
		anime++;
		if(anime >= fc)
			anime = 0;
		}
	}
}
